# define folly - we may not need this since it's installed in system path already
set(FOLLY_INCLUDE_DIRS /usr/local/include)
set(FOLLY_LIBRARY_PATH /usr/local/lib/libfolly.a)
set(FOLLY_LIBRARY folly)
add_library(${FOLLY_LIBRARY} UNKNOWN IMPORTED)
set_target_properties(${FOLLY_LIBRARY} PROPERTIES
    "IMPORTED_LOCATION" "${FOLLY_LIBRARY_PATH}"
    "IMPORTED_LINK_INTERFACE_LIBRARIES" "${CMAKE_THREAD_LIBS_INIT}"
    "INTERFACE_INCLUDE_DIRECTORIES" "${FOLLY_INCLUDE_DIRS}")

# define libiberty for linux
if(NOT APPLE)
    set(IBERTY_INCLUDE_DIRS /usr/local/include)
    set(IBERTY_LIBRARY_PATH /usr/lib/x86_64-linux-gnu/libiberty.a)
    set(IBERTY_LIBRARY iberty)
    add_library(${IBERTY_LIBRARY} UNKNOWN IMPORTED)
    set_target_properties(${IBERTY_LIBRARY} PROPERTIES
        "IMPORTED_LOCATION" "${IBERTY_LIBRARY_PATH}"
        "IMPORTED_LINK_INTERFACE_LIBRARIES" "${CMAKE_THREAD_LIBS_INIT}"
        "INTERFACE_INCLUDE_DIRECTORIES" "${IBERTY_INCLUDE_DIRS}")
endif()

target_link_libraries(${FOLLY_LIBRARY} 
    INTERFACE ${IBERTY_LIBRARY}
    INTERFACE ${DC_LIBRARY}
    INTERFACE ${EVENT_LIBRARY}
    INTERFACE ${Boost_LIBRARIES}
    INTERFACE ${ZLIB_LIBRARY}
    INTERFACE ${SNAPPY_LIBRARY}
    INTERFACE ${ZSTD_LIBRARY}
    INTERFACE ${LZ4_LIBRARY}
    INTERFACE ${BZ2_LIBRARY}
    INTERFACE ${LZMA_LIBRARY})